
vfd_chronograph_INT0_Interrupt:
	PUSH       30
	PUSH       31
	PUSH       27
	IN         27, 95
	PUSH       27
;vfd_chronograph.mbas,19 :: 		sub procedure INT0_Interrupt  org 0x01
;vfd_chronograph.mbas,20 :: 		SREG_I_bit = 0     ' disable Interrupts
	IN         27, 95
	CBR        27, 128
	OUT        95, 27
;vfd_chronograph.mbas,21 :: 		TCNT0 = 0          ' reset timer0
	LDI        27, 0
	OUT        82, 27
;vfd_chronograph.mbas,22 :: 		TCCR0B = %00001001 ' select no prescaling, clear TMR0 on compare match
	LDI        27, 9
	OUT        83, 27
;vfd_chronograph.mbas,23 :: 		TIMSK.0 = 1        ' enable interrupt on TMR0 compare match A
	IN         27, 89
	SBR        27, 1
	OUT        89, 27
;vfd_chronograph.mbas,24 :: 		SREG_I_bit = 1     ' enable Interrupts
	IN         27, 95
	SBR        27, 128
	OUT        95, 27
L_endINT0_Interrupt:
	POP        27
	OUT        95, 27
	POP        27
	POP        31
	POP        30
	RETI
; end of vfd_chronograph_INT0_Interrupt

vfd_chronograph_INT1_Interrupt:
	PUSH       30
	PUSH       31
	PUSH       27
	IN         27, 95
	PUSH       27
;vfd_chronograph.mbas,28 :: 		sub procedure INT1_Interrupt  org 0x02
;vfd_chronograph.mbas,29 :: 		SREG_I_bit = 0     ' disable Interrupts
	IN         27, 95
	CBR        27, 128
	OUT        95, 27
;vfd_chronograph.mbas,30 :: 		TIMSK.0 = 0        ' disable interrupt on TMR0 compare match A
	IN         27, 89
	CBR        27, 1
	OUT        89, 27
;vfd_chronograph.mbas,31 :: 		TCCR0B = %00001000 ' stop timer 0, clear TMR0 on compare match
	LDI        27, 8
	OUT        83, 27
;vfd_chronograph.mbas,32 :: 		TCNT0 = 0          ' reset timer0
	LDI        27, 0
	OUT        82, 27
;vfd_chronograph.mbas,34 :: 		precalc = 6000000 div count  ' since distance and time interval are set
	LDS        20, _count+0
	LDS        21, _count+1
	CLR        22
	MOV        23, 22
	LDI        16, 128
	LDI        17, 141
	LDI        18, 91
	LDI        19, 0
	CALL       _Div_32x32_U+0
	MOVW       16, 22
	MOVW       18, 24
	STS        _precalc+0, 16
	STS        _precalc+1, 17
	STS        _precalc+2, 18
	STS        _precalc+3, 19
;vfd_chronograph.mbas,37 :: 		speed = precalc
	STS        _speed+0, 16
	STS        _speed+1, 17
;vfd_chronograph.mbas,38 :: 		SREG_I_bit = 1     ' enable Interrupts
	IN         27, 95
	SBR        27, 128
	OUT        95, 27
L_endINT1_Interrupt:
	POP        27
	OUT        95, 27
	POP        27
	POP        31
	POP        30
	RETI
; end of vfd_chronograph_INT1_Interrupt

vfd_chronograph_Timer_Interrupt0:
	PUSH       30
	PUSH       31
	PUSH       27
	IN         27, 95
	PUSH       27
;vfd_chronograph.mbas,42 :: 		sub procedure Timer_Interrupt0  org 0x0D
;vfd_chronograph.mbas,43 :: 		Inc(count)
	LDS        18, _count+0
	LDS        19, _count+1
	MOVW       16, 18
	SUBI       16, 255
	SBCI       17, 255
	STS        _count+0, 16
	STS        _count+1, 17
L_endTimer_Interrupt0:
	POP        27
	OUT        95, 27
	POP        27
	POP        31
	POP        30
	RETI
; end of vfd_chronograph_Timer_Interrupt0

_main:
	LDI        27, 255
	OUT        93, 27
	LDI        27, 0
	OUT        94, 27
;vfd_chronograph.mbas,46 :: 		main:
;vfd_chronograph.mbas,49 :: 		TCCR0B = %00001000 ' stop timer 0, clear TMR0 on compare match               '
	LDI        27, 8
	OUT        83, 27
;vfd_chronograph.mbas,50 :: 		OCR0A =  50        ' set overflow at 50, giving 400kHz clocking              '
	LDI        27, 50
	OUT        86, 27
;vfd_chronograph.mbas,51 :: 		MCUCR = %00001111  ' set interrupt on rising edge for INT 0 and 1            '
	LDI        27, 15
	OUT        85, 27
;vfd_chronograph.mbas,52 :: 		GIMSK.7 = 1        ' enable INT interrupts
	IN         27, 91
	SBR        27, 128
	OUT        91, 27
;vfd_chronograph.mbas,53 :: 		GIMSK.6 = 1
	IN         27, 91
	SBR        27, 64
	OUT        91, 27
;vfd_chronograph.mbas,54 :: 		DDRB  = %01111111  ' portb output, except PB7                                '
	LDI        27, 127
	OUT        55, 27
;vfd_chronograph.mbas,55 :: 		DDRD  = %1110011   ' only pins 6 and 7 (INT0 and 1) as input on portD        '
	LDI        27, 115
	OUT        49, 27
;vfd_chronograph.mbas,56 :: 		count = 0          ' initialize variables                                    '
	LDI        27, 0
	STS        _count+0, 27
	STS        _count+1, 27
;vfd_chronograph.mbas,57 :: 		speed = 0                                                                    '
	LDI        27, 0
	STS        _speed+0, 27
	STS        _speed+1, 27
;vfd_chronograph.mbas,58 :: 		digit = 0                                                                    '
	LDI        27, 0
	STS        _digit+0, 27
;vfd_chronograph.mbas,59 :: 		grid = 0xFF                                                                  '
	LDI        27, 255
	STS        _grid+0, 27
;vfd_chronograph.mbas,60 :: 		SREG_I_bit = 1     ' Interrupt enable                                        '
	IN         27, 95
	SBR        27, 128
	OUT        95, 27
;vfd_chronograph.mbas,63 :: 		while true                ' create digits here, fun fact: takes 1243 clock cycles
L__main5:
;vfd_chronograph.mbas,65 :: 		thou = speed div 1000     ' thousands digit
	LDI        20, 232
	LDI        21, 3
	LDS        16, _speed+0
	LDS        17, _speed+1
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _thou+0, 16
	STS        _thou+1, 17
;vfd_chronograph.mbas,66 :: 		thou = thou * 1000
	LDI        20, 232
	LDI        21, 3
	CALL       _Mul_16x16+0
	STS        _thou+0, 16
	STS        _thou+1, 17
;vfd_chronograph.mbas,68 :: 		temp = speed - thou       ' hundreds digit
	MOVW       0, 16
	LDS        16, _speed+0
	LDS        17, _speed+1
	SUB        16, 0
	SBC        17, 1
	STS        _temp+0, 16
	STS        _temp+1, 17
;vfd_chronograph.mbas,69 :: 		hund = temp div 100
	LDI        20, 100
	LDI        21, 0
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _hund+0, 16
	STS        _hund+1, 17
;vfd_chronograph.mbas,70 :: 		hund = hund * 100
	LDI        20, 100
	LDI        21, 0
	CALL       _Mul_16x16+0
	STS        _hund+0, 16
	STS        _hund+1, 17
;vfd_chronograph.mbas,72 :: 		temp = thou + hund        ' tens digit
	LDS        18, _thou+0
	LDS        19, _thou+1
	ADD        16, 18
	ADC        17, 19
	STS        _temp+0, 16
	STS        _temp+1, 17
;vfd_chronograph.mbas,73 :: 		temp = speed - temp
	MOVW       0, 16
	LDS        16, _speed+0
	LDS        17, _speed+1
	SUB        16, 0
	SBC        17, 1
	STS        _temp+0, 16
	STS        _temp+1, 17
;vfd_chronograph.mbas,74 :: 		tens = temp div 10
	LDI        20, 10
	CALL       _Div_8x8_U+0
	STS        _tens+0, 16
;vfd_chronograph.mbas,75 :: 		tens = tens * 10
	LDI        20, 10
	CALL       _Mul_8x8_U+0
	STS        _tens+0, 16
;vfd_chronograph.mbas,77 :: 		temp = thou + hund        ' ones digit
	LDS        22, _thou+0
	LDS        23, _thou+1
	LDS        17, _hund+0
	LDS        18, _hund+1
	MOV        20, 17
	MOV        21, 18
	ADD        20, 22
	ADC        21, 23
	STS        _temp+0, 20
	STS        _temp+1, 21
;vfd_chronograph.mbas,78 :: 		temp = temp + tens
	MOV        18, 16
	CLR        19
	ADD        18, 20
	ADC        19, 21
	STS        _temp+0, 18
	STS        _temp+1, 19
;vfd_chronograph.mbas,79 :: 		temp = speed - temp
	LDS        16, _speed+0
	LDS        17, _speed+1
	SUB        16, 18
	SBC        17, 19
	STS        _temp+0, 16
	STS        _temp+1, 17
;vfd_chronograph.mbas,80 :: 		ones = temp
	STS        _ones+0, 16
;vfd_chronograph.mbas,82 :: 		thou = thou div 1000      ' thousands digit
	LDI        20, 232
	LDI        21, 3
	LDS        16, _thou+0
	LDS        17, _thou+1
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _thou+0, 16
	STS        _thou+1, 17
;vfd_chronograph.mbas,83 :: 		hund = hund div 100       ' hundreds digit
	LDI        20, 100
	LDI        21, 0
	LDS        16, _hund+0
	LDS        17, _hund+1
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _hund+0, 16
	STS        _hund+1, 17
;vfd_chronograph.mbas,84 :: 		tens = tens div 10        ' tens digit
	LDI        20, 10
	LDS        16, _tens+0
	CALL       _Div_8x8_U+0
	STS        _tens+0, 16
;vfd_chronograph.mbas,86 :: 		if thou = 0 then
	LDS        16, _thou+0
	LDS        17, _thou+1
	CPI        17, 0
	BRNE       L__main68
	CPI        16, 0
L__main68:
	BREQ       L__main69
	JMP        L__main10
L__main69:
;vfd_chronograph.mbas,87 :: 		thou = 10                 ' invalid digit, VFD displays nothing
	LDI        27, 10
	STS        _thou+0, 27
	LDI        27, 0
	STS        _thou+1, 27
L__main10:
;vfd_chronograph.mbas,90 :: 		digit = 0                 ' MSB = 0, LSB = 4
	LDI        27, 0
	STS        _digit+0, 27
;vfd_chronograph.mbas,91 :: 		do                        ' display digits
L__main12:
;vfd_chronograph.mbas,93 :: 		case 0
	LDS        16, _digit+0
	CPI        16, 0
	BREQ       L__main70
	JMP        L__main20
L__main70:
;vfd_chronograph.mbas,94 :: 		grid = %1111110
	LDI        27, 126
	STS        _grid+0, 27
;vfd_chronograph.mbas,95 :: 		number = thou
	LDS        16, _thou+0
	STS        _number+0, 16
	JMP        L__main17
L__main20:
;vfd_chronograph.mbas,96 :: 		case 1
	LDS        16, _digit+0
	CPI        16, 1
	BREQ       L__main71
	JMP        L__main23
L__main71:
;vfd_chronograph.mbas,97 :: 		grid = %1111101
	LDI        27, 125
	STS        _grid+0, 27
;vfd_chronograph.mbas,98 :: 		number = hund
	LDS        16, _hund+0
	STS        _number+0, 16
	JMP        L__main17
L__main23:
;vfd_chronograph.mbas,99 :: 		case 2
	LDS        16, _digit+0
	CPI        16, 2
	BREQ       L__main72
	JMP        L__main26
L__main72:
;vfd_chronograph.mbas,100 :: 		grid = %1101111
	LDI        27, 111
	STS        _grid+0, 27
;vfd_chronograph.mbas,101 :: 		number = 2                    ' number two activates correct dot
	LDI        27, 2
	STS        _number+0, 27
	JMP        L__main17
L__main26:
;vfd_chronograph.mbas,102 :: 		case 3
	LDS        16, _digit+0
	CPI        16, 3
	BREQ       L__main73
	JMP        L__main29
L__main73:
;vfd_chronograph.mbas,103 :: 		grid = %1011111
	LDI        27, 95
	STS        _grid+0, 27
;vfd_chronograph.mbas,104 :: 		number = tens
	LDS        16, _tens+0
	STS        _number+0, 16
	JMP        L__main17
L__main29:
;vfd_chronograph.mbas,105 :: 		case 4
	LDS        16, _digit+0
	CPI        16, 4
	BREQ       L__main74
	JMP        L__main32
L__main74:
;vfd_chronograph.mbas,106 :: 		grid = %0111111
	LDI        27, 63
	STS        _grid+0, 27
;vfd_chronograph.mbas,107 :: 		number = ones
	LDS        16, _ones+0
	STS        _number+0, 16
	JMP        L__main17
L__main32:
L__main17:
;vfd_chronograph.mbas,110 :: 		portB = 0
	LDI        27, 0
	OUT        56, 27
;vfd_chronograph.mbas,111 :: 		delay_us(10)                        ' time for display to blank
	LDI        16, 66
	DEC        16
	BRNE       $-1
	NOP
	NOP
;vfd_chronograph.mbas,112 :: 		portD = grid
	LDS        16, _grid+0
	OUT        50, 16
;vfd_chronograph.mbas,115 :: 		case 0
	LDS        16, _number+0
	CPI        16, 0
	BREQ       L__main75
	JMP        L__main36
L__main75:
;vfd_chronograph.mbas,116 :: 		portb = 192
	LDI        27, 192
	OUT        56, 27
	JMP        L__main33
L__main36:
;vfd_chronograph.mbas,117 :: 		case 1
	LDS        16, _number+0
	CPI        16, 1
	BREQ       L__main76
	JMP        L__main39
L__main76:
;vfd_chronograph.mbas,118 :: 		portb = 249
	LDI        27, 249
	OUT        56, 27
	JMP        L__main33
L__main39:
;vfd_chronograph.mbas,119 :: 		case 2
	LDS        16, _number+0
	CPI        16, 2
	BREQ       L__main77
	JMP        L__main42
L__main77:
;vfd_chronograph.mbas,120 :: 		portb = 164
	LDI        27, 164
	OUT        56, 27
	JMP        L__main33
L__main42:
;vfd_chronograph.mbas,121 :: 		case 3
	LDS        16, _number+0
	CPI        16, 3
	BREQ       L__main78
	JMP        L__main45
L__main78:
;vfd_chronograph.mbas,122 :: 		portb = 176
	LDI        27, 176
	OUT        56, 27
	JMP        L__main33
L__main45:
;vfd_chronograph.mbas,123 :: 		case 4
	LDS        16, _number+0
	CPI        16, 4
	BREQ       L__main79
	JMP        L__main48
L__main79:
;vfd_chronograph.mbas,124 :: 		portb = 153
	LDI        27, 153
	OUT        56, 27
	JMP        L__main33
L__main48:
;vfd_chronograph.mbas,125 :: 		case 5
	LDS        16, _number+0
	CPI        16, 5
	BREQ       L__main80
	JMP        L__main51
L__main80:
;vfd_chronograph.mbas,126 :: 		portb = 146
	LDI        27, 146
	OUT        56, 27
	JMP        L__main33
L__main51:
;vfd_chronograph.mbas,127 :: 		case 6
	LDS        16, _number+0
	CPI        16, 6
	BREQ       L__main81
	JMP        L__main54
L__main81:
;vfd_chronograph.mbas,128 :: 		portb = 130
	LDI        27, 130
	OUT        56, 27
	JMP        L__main33
L__main54:
;vfd_chronograph.mbas,129 :: 		case 7
	LDS        16, _number+0
	CPI        16, 7
	BREQ       L__main82
	JMP        L__main57
L__main82:
;vfd_chronograph.mbas,130 :: 		portb = 248
	LDI        27, 248
	OUT        56, 27
	JMP        L__main33
L__main57:
;vfd_chronograph.mbas,131 :: 		case 8
	LDS        16, _number+0
	CPI        16, 8
	BREQ       L__main83
	JMP        L__main60
L__main83:
;vfd_chronograph.mbas,132 :: 		portb = 0
	LDI        27, 0
	OUT        56, 27
	JMP        L__main33
L__main60:
;vfd_chronograph.mbas,133 :: 		case 9
	LDS        16, _number+0
	CPI        16, 9
	BREQ       L__main84
	JMP        L__main63
L__main84:
;vfd_chronograph.mbas,134 :: 		portb = 152
	LDI        27, 152
	OUT        56, 27
	JMP        L__main33
L__main63:
;vfd_chronograph.mbas,136 :: 		portb = 127          ' displays nothing if number doesn't exsist
	LDI        27, 127
	OUT        56, 27
L__main33:
;vfd_chronograph.mbas,139 :: 		Inc(digit)                ' digit control so grids are activiated accordingly
	LDS        16, _digit+0
	SUBI       16, 255
	STS        _digit+0, 16
;vfd_chronograph.mbas,140 :: 		delay_us(200)             ' time for digit to be perceived by eye
	LDI        17, 6
	LDI        16, 49
	DEC        16
	BRNE       $-1
	DEC        17
	BRNE       $-3
;vfd_chronograph.mbas,141 :: 		loop until digit = 5
	LDS        16, _digit+0
	CPI        16, 5
	BRNE       L__main85
	JMP        L__main15
L__main85:
	JMP        L__main12
L__main15:
	JMP        L__main5
;vfd_chronograph.mbas,142 :: 		wend
L_endmain:
	JMP        L_endmain
; end of _main
