
vfd_chronograph_INT0_Interrupt:
	PUSH       30
	PUSH       31
	PUSH       27
	IN         27, 95
	PUSH       27
;vfd_chronograph.mbas,21 :: 		sub procedure INT0_Interrupt  org 0x01
;vfd_chronograph.mbas,22 :: 		SREG_I_bit = 0     ' disable Interrupts
	IN         27, 95
	CBR        27, 128
	OUT        95, 27
;vfd_chronograph.mbas,23 :: 		TCNT0 = 0          ' reset timer0
	LDI        27, 0
	OUT        82, 27
;vfd_chronograph.mbas,24 :: 		count = 0          ' reset count
	LDI        27, 0
	STS        _count+0, 27
	STS        _count+1, 27
;vfd_chronograph.mbas,25 :: 		TCCR0B = %00001001 ' set no prescaling, clear TMR0 on compare match
	LDI        27, 9
	OUT        83, 27
;vfd_chronograph.mbas,26 :: 		TIMSK.0 = 1        ' enable interrupt on TMR0 compare match A
	IN         27, 89
	SBR        27, 1
	OUT        89, 27
;vfd_chronograph.mbas,27 :: 		SREG_I_bit = 1     ' enable Interrupts
	IN         27, 95
	SBR        27, 128
	OUT        95, 27
L_endINT0_Interrupt:
	POP        27
	OUT        95, 27
	POP        27
	POP        31
	POP        30
	RETI
; end of vfd_chronograph_INT0_Interrupt

vfd_chronograph_INT1_Interrupt:
	PUSH       30
	PUSH       31
	PUSH       27
	IN         27, 95
	PUSH       27
;vfd_chronograph.mbas,31 :: 		sub procedure INT1_Interrupt  org 0x02
;vfd_chronograph.mbas,32 :: 		TCCR0B = %00001000 ' stop timer 0, clear TMR0 on compare match
	LDI        27, 8
	OUT        83, 27
;vfd_chronograph.mbas,33 :: 		SREG_I_bit = 0     ' disable Interrupts
	IN         27, 95
	CBR        27, 128
	OUT        95, 27
;vfd_chronograph.mbas,34 :: 		TIMSK.0 = 0        ' disable interrupt on TMR0 compare match A
	IN         27, 89
	CBR        27, 1
	OUT        89, 27
;vfd_chronograph.mbas,35 :: 		temp2 = TCNT0
	IN         16, 82
	STS        _temp2+0, 16
	CLR        27
	STS        _temp2+1, 27
;vfd_chronograph.mbas,37 :: 		if count = 0 then
	LDS        16, _count+0
	LDS        17, _count+1
	CPI        17, 0
	BRNE       L_vfd_chronograph_INT1_Interrupt75
	CPI        16, 0
L_vfd_chronograph_INT1_Interrupt75:
	BREQ       L_vfd_chronograph_INT1_Interrupt76
	JMP        L_vfd_chronograph_INT1_Interrupt3
L_vfd_chronograph_INT1_Interrupt76:
;vfd_chronograph.mbas,38 :: 		speed = 0
	LDI        27, 0
	STS        _speed+0, 27
	STS        _speed+1, 27
	JMP        L_vfd_chronograph_INT1_Interrupt4
;vfd_chronograph.mbas,39 :: 		else
L_vfd_chronograph_INT1_Interrupt3:
;vfd_chronograph.mbas,40 :: 		if temp2 <> 0 then
	LDS        16, _temp2+0
	LDS        17, _temp2+1
	CPI        17, 0
	BRNE       L_vfd_chronograph_INT1_Interrupt77
	CPI        16, 0
L_vfd_chronograph_INT1_Interrupt77:
	BRNE       L_vfd_chronograph_INT1_Interrupt78
	JMP        L_vfd_chronograph_INT1_Interrupt6
L_vfd_chronograph_INT1_Interrupt78:
;vfd_chronograph.mbas,41 :: 		temp2 = temp2 * 10                ' Division by TMR0 overflow value to get-
	LDS        16, _temp2+0
	LDS        17, _temp2+1
	LDI        20, 10
	LDI        21, 0
	CALL       _Mul_16x16+0
	STS        _temp2+0, 16
	STS        _temp2+1, 17
;vfd_chronograph.mbas,42 :: 		temp2 = temp2 div 24              ' fraction of 12s increment
	LDI        20, 24
	LDI        21, 0
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _temp2+0, 16
	STS        _temp2+1, 17
L_vfd_chronograph_INT1_Interrupt6:
;vfd_chronograph.mbas,44 :: 		precalc = count * 100             ' to allow for decimal places due to temp2
	LDS        16, _count+0
	LDS        17, _count+1
	CLR        18
	MOV        19, 18
	LDI        20, 100
	LDI        21, 0
	LDI        22, 0
	LDI        23, 0
	CALL       _Mul_32x32+0
	STS        _precalc+0, 16
	STS        _precalc+1, 17
	STS        _precalc+2, 18
	STS        _precalc+3, 19
;vfd_chronograph.mbas,45 :: 		precalc = precalc + temp2         ' addition of decimals
	LDS        20, _temp2+0
	LDS        21, _temp2+1
	CLR        22
	MOV        23, 22
	ADD        20, 16
	ADC        21, 17
	ADC        22, 18
	ADC        23, 19
	STS        _precalc+0, 20
	STS        _precalc+1, 21
	STS        _precalc+2, 22
	STS        _precalc+3, 23
;vfd_chronograph.mbas,46 :: 		precalc = 125000000 div precalc   ' 125000000 because distance and time intervals
	LDI        16, 64
	LDI        17, 89
	LDI        18, 115
	LDI        19, 7
	CALL       _Div_32x32_U+0
	MOVW       16, 22
	MOVW       18, 24
	STS        _precalc+0, 16
	STS        _precalc+1, 17
	STS        _precalc+2, 18
	STS        _precalc+3, 19
;vfd_chronograph.mbas,47 :: 		speed = precalc                   ' are constant. Extra 100 for decimal places from
	STS        _speed+0, 16
	STS        _speed+1, 17
;vfd_chronograph.mbas,49 :: 		end if
L_vfd_chronograph_INT1_Interrupt4:
;vfd_chronograph.mbas,50 :: 		TCNT0 = 0             ' reset timer0
	LDI        27, 0
	OUT        82, 27
;vfd_chronograph.mbas,51 :: 		SREG_I_bit = 1        ' enable Interrupts
	IN         27, 95
	SBR        27, 128
	OUT        95, 27
L_endINT1_Interrupt:
	POP        27
	OUT        95, 27
	POP        27
	POP        31
	POP        30
	RETI
; end of vfd_chronograph_INT1_Interrupt

vfd_chronograph_Timer_Interrupt0:
	PUSH       30
	PUSH       31
	PUSH       27
	IN         27, 95
	PUSH       27
;vfd_chronograph.mbas,55 :: 		sub procedure Timer_Interrupt0  org 0x0D
;vfd_chronograph.mbas,56 :: 		Inc(count)            ' add 3s to counter
	LDS        18, _count+0
	LDS        19, _count+1
	MOVW       16, 18
	SUBI       16, 255
	SBCI       17, 255
	STS        _count+0, 16
	STS        _count+1, 17
;vfd_chronograph.mbas,57 :: 		if SREG.1 = 1 then    ' False trigger of first sensor (count overflow)
	IN         27, 95
	SBRS       27, 1
	JMP        L_vfd_chronograph_Timer_Interrupt010
;vfd_chronograph.mbas,58 :: 		SREG_I_bit = 0        ' disable Interrupts
	IN         27, 95
	CBR        27, 128
	OUT        95, 27
;vfd_chronograph.mbas,59 :: 		TCCR0B = %00001000    ' stop timer 0, clear TMR0 on compare match
	LDI        27, 8
	OUT        83, 27
;vfd_chronograph.mbas,60 :: 		TIMSK.0 = 0           ' disable interrupt on TMR0 compare match A
	IN         27, 89
	CBR        27, 1
	OUT        89, 27
;vfd_chronograph.mbas,61 :: 		count = 0
	LDI        27, 0
	STS        _count+0, 27
	STS        _count+1, 27
;vfd_chronograph.mbas,62 :: 		SREG_I_bit = 1        ' enable Interrupts
	IN         27, 95
	SBR        27, 128
	OUT        95, 27
L_vfd_chronograph_Timer_Interrupt010:
;vfd_chronograph.mbas,63 :: 		end if
L_endTimer_Interrupt0:
	POP        27
	OUT        95, 27
	POP        27
	POP        31
	POP        30
	RETI
; end of vfd_chronograph_Timer_Interrupt0

_main:
	LDI        27, 255
	OUT        93, 27
	LDI        27, 0
	OUT        94, 27
;vfd_chronograph.mbas,66 :: 		main:
;vfd_chronograph.mbas,69 :: 		TCCR0B = %00001000 ' stop timer 0, clear TMR0 on compare match               '
	LDI        27, 8
	OUT        83, 27
;vfd_chronograph.mbas,70 :: 		OCR0A =  240        ' set overflow at 240, giving 83.3kHz clocking           '
	LDI        27, 240
	OUT        86, 27
;vfd_chronograph.mbas,71 :: 		MCUCR = %00001111  ' set interrupt on rising edge for INT 0 and 1            '
	LDI        27, 15
	OUT        85, 27
;vfd_chronograph.mbas,72 :: 		GIMSK.7 = 1        ' enable INT interrupts                                   '
	IN         27, 91
	SBR        27, 128
	OUT        91, 27
;vfd_chronograph.mbas,73 :: 		GIMSK.6 = 1                                                                  '
	IN         27, 91
	SBR        27, 64
	OUT        91, 27
;vfd_chronograph.mbas,74 :: 		DDRB  = %01111111  ' portb output, except PB7                                '
	LDI        27, 127
	OUT        55, 27
;vfd_chronograph.mbas,75 :: 		DDRD  = %1110011   ' only pins 6 and 7 (INT0 and 1) as input on portD        '
	LDI        27, 115
	OUT        49, 27
;vfd_chronograph.mbas,76 :: 		count = 0          ' initialize variables                                    '
	LDI        27, 0
	STS        _count+0, 27
	STS        _count+1, 27
;vfd_chronograph.mbas,77 :: 		speed = 0                                                                    '
	LDI        27, 0
	STS        _speed+0, 27
	STS        _speed+1, 27
;vfd_chronograph.mbas,78 :: 		digit = 0                                                                    '
	LDI        27, 0
	STS        _digit+0, 27
;vfd_chronograph.mbas,79 :: 		grid = 0xFF                                                                  '
	LDI        27, 255
	STS        _grid+0, 27
;vfd_chronograph.mbas,80 :: 		SREG_I_bit = 1     ' Interrupt enable                                        '
	IN         27, 95
	SBR        27, 128
	OUT        95, 27
;vfd_chronograph.mbas,83 :: 		while true
L__main14:
;vfd_chronograph.mbas,86 :: 		thou = speed div 1000     ' thousands digit
	LDI        20, 232
	LDI        21, 3
	LDS        16, _speed+0
	LDS        17, _speed+1
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _thou+0, 16
	STS        _thou+1, 17
;vfd_chronograph.mbas,88 :: 		hund = speed mod 1000     ' hundreds digit
	LDI        20, 232
	LDI        21, 3
	LDS        16, _speed+0
	LDS        17, _speed+1
	CALL       _Div_16x16_U+0
	MOVW       16, 26
	STS        _hund+0, 16
	STS        _hund+1, 17
;vfd_chronograph.mbas,89 :: 		hund = hund div 100
	LDI        20, 100
	LDI        21, 0
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _hund+0, 16
	STS        _hund+1, 17
;vfd_chronograph.mbas,91 :: 		temp = speed mod 100      ' tens digit
	LDI        20, 100
	LDI        21, 0
	LDS        16, _speed+0
	LDS        17, _speed+1
	CALL       _Div_16x16_U+0
	MOVW       16, 26
	STS        _temp+0, 16
	STS        _temp+1, 17
;vfd_chronograph.mbas,92 :: 		temp = temp div 10
	LDI        20, 10
	LDI        21, 0
	CALL       _Div_16x16_U+0
	MOVW       16, 24
	STS        _temp+0, 16
	STS        _temp+1, 17
;vfd_chronograph.mbas,93 :: 		tens = temp
	STS        _tens+0, 16
;vfd_chronograph.mbas,95 :: 		temp = speed mod 10       ' ones digit
	LDI        20, 10
	LDI        21, 0
	LDS        16, _speed+0
	LDS        17, _speed+1
	CALL       _Div_16x16_U+0
	MOVW       16, 26
	STS        _temp+0, 16
	STS        _temp+1, 17
;vfd_chronograph.mbas,96 :: 		ones = temp
	STS        _ones+0, 16
;vfd_chronograph.mbas,98 :: 		if thou = 0 then
	LDS        16, _thou+0
	LDS        17, _thou+1
	CPI        17, 0
	BRNE       L__main81
	CPI        16, 0
L__main81:
	BREQ       L__main82
	JMP        L__main19
L__main82:
;vfd_chronograph.mbas,99 :: 		thou = 10                 ' invalid digit, VFD displays nothing
	LDI        27, 10
	STS        _thou+0, 27
	LDI        27, 0
	STS        _thou+1, 27
L__main19:
;vfd_chronograph.mbas,102 :: 		digit = 0                 ' MSB = 0, LSB = 4
	LDI        27, 0
	STS        _digit+0, 27
;vfd_chronograph.mbas,104 :: 		do                        ' display digits
L__main21:
;vfd_chronograph.mbas,106 :: 		case 0
	LDS        16, _digit+0
	CPI        16, 0
	BREQ       L__main83
	JMP        L__main29
L__main83:
;vfd_chronograph.mbas,107 :: 		grid = %1111110
	LDI        27, 126
	STS        _grid+0, 27
;vfd_chronograph.mbas,108 :: 		number = thou
	LDS        16, _thou+0
	STS        _number+0, 16
	JMP        L__main26
L__main29:
;vfd_chronograph.mbas,109 :: 		case 1
	LDS        16, _digit+0
	CPI        16, 1
	BREQ       L__main84
	JMP        L__main32
L__main84:
;vfd_chronograph.mbas,110 :: 		grid = %1111101
	LDI        27, 125
	STS        _grid+0, 27
;vfd_chronograph.mbas,111 :: 		number = hund
	LDS        16, _hund+0
	STS        _number+0, 16
	JMP        L__main26
L__main32:
;vfd_chronograph.mbas,112 :: 		case 2
	LDS        16, _digit+0
	CPI        16, 2
	BREQ       L__main85
	JMP        L__main35
L__main85:
;vfd_chronograph.mbas,113 :: 		grid = %1101111
	LDI        27, 111
	STS        _grid+0, 27
;vfd_chronograph.mbas,114 :: 		number = 2                    ' number two activates correct dot
	LDI        27, 2
	STS        _number+0, 27
	JMP        L__main26
L__main35:
;vfd_chronograph.mbas,115 :: 		case 3
	LDS        16, _digit+0
	CPI        16, 3
	BREQ       L__main86
	JMP        L__main38
L__main86:
;vfd_chronograph.mbas,116 :: 		grid = %1011111
	LDI        27, 95
	STS        _grid+0, 27
;vfd_chronograph.mbas,117 :: 		number = tens
	LDS        16, _tens+0
	STS        _number+0, 16
	JMP        L__main26
L__main38:
;vfd_chronograph.mbas,118 :: 		case 4
	LDS        16, _digit+0
	CPI        16, 4
	BREQ       L__main87
	JMP        L__main41
L__main87:
;vfd_chronograph.mbas,119 :: 		grid = %0111111
	LDI        27, 63
	STS        _grid+0, 27
;vfd_chronograph.mbas,120 :: 		number = ones
	LDS        16, _ones+0
	STS        _number+0, 16
	JMP        L__main26
L__main41:
L__main26:
;vfd_chronograph.mbas,123 :: 		portB = 0
	LDI        27, 0
	OUT        56, 27
;vfd_chronograph.mbas,124 :: 		delay_us(10)                        ' time for display to blank
	LDI        16, 66
	DEC        16
	BRNE       $-1
	NOP
	NOP
;vfd_chronograph.mbas,125 :: 		portD = grid
	LDS        16, _grid+0
	OUT        50, 16
;vfd_chronograph.mbas,128 :: 		case 0
	LDS        16, _number+0
	CPI        16, 0
	BREQ       L__main88
	JMP        L__main45
L__main88:
;vfd_chronograph.mbas,129 :: 		portb = 192
	LDI        27, 192
	OUT        56, 27
	JMP        L__main42
L__main45:
;vfd_chronograph.mbas,130 :: 		case 1
	LDS        16, _number+0
	CPI        16, 1
	BREQ       L__main89
	JMP        L__main48
L__main89:
;vfd_chronograph.mbas,131 :: 		portb = 249
	LDI        27, 249
	OUT        56, 27
	JMP        L__main42
L__main48:
;vfd_chronograph.mbas,132 :: 		case 2
	LDS        16, _number+0
	CPI        16, 2
	BREQ       L__main90
	JMP        L__main51
L__main90:
;vfd_chronograph.mbas,133 :: 		portb = 164
	LDI        27, 164
	OUT        56, 27
	JMP        L__main42
L__main51:
;vfd_chronograph.mbas,134 :: 		case 3
	LDS        16, _number+0
	CPI        16, 3
	BREQ       L__main91
	JMP        L__main54
L__main91:
;vfd_chronograph.mbas,135 :: 		portb = 176
	LDI        27, 176
	OUT        56, 27
	JMP        L__main42
L__main54:
;vfd_chronograph.mbas,136 :: 		case 4
	LDS        16, _number+0
	CPI        16, 4
	BREQ       L__main92
	JMP        L__main57
L__main92:
;vfd_chronograph.mbas,137 :: 		portb = 153
	LDI        27, 153
	OUT        56, 27
	JMP        L__main42
L__main57:
;vfd_chronograph.mbas,138 :: 		case 5
	LDS        16, _number+0
	CPI        16, 5
	BREQ       L__main93
	JMP        L__main60
L__main93:
;vfd_chronograph.mbas,139 :: 		portb = 146
	LDI        27, 146
	OUT        56, 27
	JMP        L__main42
L__main60:
;vfd_chronograph.mbas,140 :: 		case 6
	LDS        16, _number+0
	CPI        16, 6
	BREQ       L__main94
	JMP        L__main63
L__main94:
;vfd_chronograph.mbas,141 :: 		portb = 130
	LDI        27, 130
	OUT        56, 27
	JMP        L__main42
L__main63:
;vfd_chronograph.mbas,142 :: 		case 7
	LDS        16, _number+0
	CPI        16, 7
	BREQ       L__main95
	JMP        L__main66
L__main95:
;vfd_chronograph.mbas,143 :: 		portb = 248
	LDI        27, 248
	OUT        56, 27
	JMP        L__main42
L__main66:
;vfd_chronograph.mbas,144 :: 		case 8
	LDS        16, _number+0
	CPI        16, 8
	BREQ       L__main96
	JMP        L__main69
L__main96:
;vfd_chronograph.mbas,145 :: 		portb = 0
	LDI        27, 0
	OUT        56, 27
	JMP        L__main42
L__main69:
;vfd_chronograph.mbas,146 :: 		case 9
	LDS        16, _number+0
	CPI        16, 9
	BREQ       L__main97
	JMP        L__main72
L__main97:
;vfd_chronograph.mbas,147 :: 		portb = 152
	LDI        27, 152
	OUT        56, 27
	JMP        L__main42
L__main72:
;vfd_chronograph.mbas,149 :: 		portb = 127          ' displays nothing if number doesn't exsist
	LDI        27, 127
	OUT        56, 27
L__main42:
;vfd_chronograph.mbas,152 :: 		Inc(digit)                ' digit control so grids are activiated accordingly
	LDS        16, _digit+0
	SUBI       16, 255
	STS        _digit+0, 16
;vfd_chronograph.mbas,153 :: 		delay_us(200)             ' time for digit to be perceived by eye
	LDI        17, 6
	LDI        16, 49
	DEC        16
	BRNE       $-1
	DEC        17
	BRNE       $-3
;vfd_chronograph.mbas,154 :: 		loop until digit = 5
	LDS        16, _digit+0
	CPI        16, 5
	BRNE       L__main98
	JMP        L__main24
L__main98:
	JMP        L__main21
L__main24:
	JMP        L__main14
;vfd_chronograph.mbas,155 :: 		wend
L_endmain:
	JMP        L_endmain
; end of _main
